// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2024 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Fitness.idl.

package com.raritan.idl.fitness;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Fitness {
  static public final TypeInfo typeInfo = new TypeInfo("fitness.Fitness:1.0.0", null);

  public static final int FLAG_VALUE_INVALID = 0x1;

  public static final int FLAG_VALUE_OLD = 0x2;

  public static final int FLAG_ENTRY_CRITICAL = 0x4;

  static public class DataEntry implements Cloneable {
    public String id = new String();
    public int value = 0;
    public int maxValue = 0;
    public int worstValue = 0;
    public int thresholdValue = 0;
    public long rawValue = 0;
    public int flags = 0;

    public Object clone() {
      DataEntry copy = new DataEntry();

      copy.id = this.id;
      copy.value = this.value;
      copy.maxValue = this.maxValue;
      copy.worstValue = this.worstValue;
      copy.thresholdValue = this.thresholdValue;
      copy.rawValue = this.rawValue;
      copy.flags = this.flags;

      return copy;
    }

  }

  static public class ErrorLogEntry implements Cloneable {
    public String id = new String();
    public int value = 0;
    public int thresholdValue = 0;
    public long rawValue = 0;
    public int powerOnHours = 0;
    public java.util.Date timeStampUTC = new java.util.Date();

    public Object clone() {
      ErrorLogEntry copy = new ErrorLogEntry();

      copy.id = this.id;
      copy.value = this.value;
      copy.thresholdValue = this.thresholdValue;
      copy.rawValue = this.rawValue;
      copy.powerOnHours = this.powerOnHours;
      copy.timeStampUTC = this.timeStampUTC;

      return copy;
    }

  }

  public class GetDataEntriesResult {
    public java.util.List<com.raritan.idl.fitness.Fitness.DataEntry> _ret_;
  }

  GetDataEntriesResult getDataEntries() throws Exception;

  AsyncRequest getDataEntries(AsyncRpcResponse<GetDataEntriesResult> rsp);

  AsyncRequest getDataEntries(AsyncRpcResponse<GetDataEntriesResult> rsp, RpcCtrl rpcCtrl);


  public class GetErrorLogIndexRangeResult {
    public int firstIndex;
    public int entryCount;
  }

  GetErrorLogIndexRangeResult getErrorLogIndexRange() throws Exception;

  AsyncRequest getErrorLogIndexRange(AsyncRpcResponse<GetErrorLogIndexRangeResult> rsp);

  AsyncRequest getErrorLogIndexRange(AsyncRpcResponse<GetErrorLogIndexRangeResult> rsp, RpcCtrl rpcCtrl);


  public class GetErrorLogEntriesResult {
    public java.util.List<com.raritan.idl.fitness.Fitness.ErrorLogEntry> _ret_;
  }

  GetErrorLogEntriesResult getErrorLogEntries(int startIndex, int count) throws Exception;

  AsyncRequest getErrorLogEntries(int startIndex, int count, AsyncRpcResponse<GetErrorLogEntriesResult> rsp);

  AsyncRequest getErrorLogEntries(int startIndex, int count, AsyncRpcResponse<GetErrorLogEntriesResult> rsp, RpcCtrl rpcCtrl);

}
