// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2024 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from KeypadManager.idl.

package com.raritan.idl.smartlock;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface KeypadManager {
  static public final TypeInfo typeInfo = new TypeInfo("smartlock.KeypadManager:1.0.0", null);

  static public class KeypadSettings implements Cloneable {
    public String name = new String();
    public String description = new String();

    public Object clone() {
      KeypadSettings copy = new KeypadSettings();

      copy.name = this.name;
      copy.description = this.description;

      return copy;
    }

  }

  public class KeypadEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("smartlock.KeypadManager.KeypadEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.smartlock.Keypad keypad = null;
  }

  public class KeypadAttachedEvent extends com.raritan.idl.smartlock.KeypadManager.KeypadEvent {

    static public final TypeInfo typeInfo = new TypeInfo("smartlock.KeypadManager.KeypadAttachedEvent:1.0.0", com.raritan.idl.smartlock.KeypadManager.KeypadEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

  }

  public class KeypadDetachedEvent extends com.raritan.idl.smartlock.KeypadManager.KeypadEvent {

    static public final TypeInfo typeInfo = new TypeInfo("smartlock.KeypadManager.KeypadDetachedEvent:1.0.0", com.raritan.idl.smartlock.KeypadManager.KeypadEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

  }

  public class KeypadSettingsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("smartlock.KeypadManager.KeypadSettingsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.smartlock.KeypadManager.KeypadSettings oldSettings = new com.raritan.idl.smartlock.KeypadManager.KeypadSettings();
    public com.raritan.idl.smartlock.KeypadManager.KeypadSettings newSettings = new com.raritan.idl.smartlock.KeypadManager.KeypadSettings();
    public String position = new String();
  }

  public class GetKeypadsResult {
    public java.util.List<com.raritan.idl.smartlock.Keypad> _ret_;
  }

  GetKeypadsResult getKeypads() throws Exception;

  AsyncRequest getKeypads(AsyncRpcResponse<GetKeypadsResult> rsp);

  AsyncRequest getKeypads(AsyncRpcResponse<GetKeypadsResult> rsp, RpcCtrl rpcCtrl);


  public class GetKeypadByIdResult {
    public com.raritan.idl.smartlock.Keypad _ret_;
  }

  GetKeypadByIdResult getKeypadById(String keypadId) throws Exception;

  AsyncRequest getKeypadById(String keypadId, AsyncRpcResponse<GetKeypadByIdResult> rsp);

  AsyncRequest getKeypadById(String keypadId, AsyncRpcResponse<GetKeypadByIdResult> rsp, RpcCtrl rpcCtrl);


  public class SetKeypadSettingsResult {
    public int _ret_;
  }

  SetKeypadSettingsResult setKeypadSettings(String position, com.raritan.idl.smartlock.KeypadManager.KeypadSettings setting) throws Exception;

  AsyncRequest setKeypadSettings(String position, com.raritan.idl.smartlock.KeypadManager.KeypadSettings setting, AsyncRpcResponse<SetKeypadSettingsResult> rsp);

  AsyncRequest setKeypadSettings(String position, com.raritan.idl.smartlock.KeypadManager.KeypadSettings setting, AsyncRpcResponse<SetKeypadSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class GetAllKeypadSettingsResult {
    public java.util.Map<String, com.raritan.idl.smartlock.KeypadManager.KeypadSettings> _ret_;
  }

  GetAllKeypadSettingsResult getAllKeypadSettings() throws Exception;

  AsyncRequest getAllKeypadSettings(AsyncRpcResponse<GetAllKeypadSettingsResult> rsp);

  AsyncRequest getAllKeypadSettings(AsyncRpcResponse<GetAllKeypadSettingsResult> rsp, RpcCtrl rpcCtrl);

}
